JavaScript Data GridCell renderer

Create a custom cell renderer function, to have full control over how a cell looks.

Overview

When you create a renderer, a good idea is to assign it as an alias that will refer to this particular renderer function. Handsontable defines 10 aliases by default:

  • autocomplete for Handsontable.renderers.AutocompleteRenderer
  • base for Handsontable.renderers.BaseRenderer
  • checkbox for Handsontable.renderers.CheckboxRenderer
  • date for Handsontable.renderers.DateRenderer
  • dropdown for Handsontable.renderers.DropdownRenderer
  • html for Handsontable.renderers.HtmlRenderer
  • numeric for Handsontable.renderers.NumericRenderer
  • password for Handsontable.renderers.PasswordRenderer
  • text for Handsontable.renderers.TextRenderer
  • time for Handsontable.renderers.TimeRenderer

It gives users a convenient way for defining which renderer should be used when table rendering was triggered. User doesn't need to know which renderer function is responsible for displaying the cell value, he does not even need to know that there is any function at all. What is more, you can change the render function associated with an alias without a need to change code that defines a table.

Use a cell renderer

Use the renderer name of your choice when configuring the column:

const container = document.querySelector('#container');
const hot = new Handsontable(container, {
  data: someData,
  columns: [{
    renderer: 'numeric'
  }]
});

Register custom cell renderer

To register your own alias use Handsontable.renderers.registerRenderer() function. It takes two arguments:

  • rendererName - a string representing a renderer function
  • renderer - a renderer function that will be represented by rendererName

If you'd like to register asterixDecoratorRenderer under alias asterix you have to call:

Handsontable.renderers.registerRenderer('asterix', asterixDecoratorRenderer);

Choose aliases wisely. If you register your renderer under name that is already registered, the target function will be overwritten:

Handsontable.renderers.registerRenderer('text', asterixDecoratorRenderer);

Now 'text' alias points to asterixDecoratorRenderer function, not Handsontable.renderers.TextRenderer.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your renderer, because you never know aliases has been registered by the user who uses your renderer.

Handsontable.renderers.registerRenderer('asterix', asterixDecoratorRenderer);

Someone might already registered such alias

Handsontable.renderers.registerRenderer('my.asterix', asterixDecoratorRenderer);

That's better.

Use an alias

The final touch is to using the registered aliases, so that users can easily refer to it without the need to now the actual renderer function is.

To sum up, a well prepared renderer function should look like this:

function customRenderer(hotInstance, td, row, column, prop, value, cellProperties) {
  // Optionally include `BaseRenderer` which is responsible for
  // adding/removing CSS classes to/from the table cells.
  Handsontable.renderers.BaseRenderer.apply(this, arguments);

  // ...your custom logic of the renderer
}

// Register an alias
Handsontable.renderers.registerRenderer('my.custom', customRenderer);

From now on, you can use customRenderer like so:

const container = document.querySelector('#container');
const hot = new Handsontable(container, {
  data: someData,
  columns: [{
    renderer: 'my.custom'
  }]
});

Render custom HTML in cells

This example shows how to use custom cell renderers to display HTML content in a cell. This is a very powerful feature. Just remember to escape any HTML code that could be used for XSS attacks. In the below configuration:

  • Title column uses built-in HTML renderer that allows any HTML. This is unsafe if your code comes from untrusted source. Take notice that a Handsontable user can use it to enter <script> or other potentially malicious tags using the cell editor!
  • Description column also uses HTML renderer (same as above)
  • Comments column uses a custom renderer (safeHtmlRenderer). This should be safe for user input, because only certain tags are allowed
  • Cover column accepts image URL as a string and converts it to a <img> in the renderer

    Render custom HTML in header

    You can also put HTML into row and column headers. If you need to attach events to DOM elements like the checkbox below, just remember to identify the element by class name, not by id. This is because row and column headers are duplicated in the DOM tree and id attribute must be unique.

      Add event listeners in cell renderer function

      If you are writing an advanced cell renderer, and you want to add some custom behavior after a certain user action (i.e. after user hover a mouse pointer over a cell) you might be tempted to add an event listener directly to table cell node passed as an argument to the renderer function. Unfortunately, this will almost always cause you trouble and you will end up with either performance issues or having the listeners attached to the wrong cell.

      This is because Handsontable:

      • Calls renderer functions multiple times per cell - this can lead to having multiple copies of the same event listener attached to a cell
      • Reuses table cell nodes during table scrolling and adding/removing new rows/columns - this can lead to having event listeners attached to the wrong cell

      Before deciding to attach an event listener in cell renderer make sure, that there is no Handsontable event that suits your needs. Using Handsontable events system is the safest way to respond to user actions.

      If you did't find a suitable Handsontable event put the cell content into a wrapping <div>, attach the event listener to the wrapper and then put it into the table cell.

      Performance considerations

      Cell renderers are called separately for every displayed cell, during every table render. Table can be rendered multiple times during its lifetime (after table scroll, after table sorting, after cell edit etc.), therefore you should keep your renderer functions as simple and fast as possible or you might experience a performance drop, especially when dealing with large sets of data.

React Data GridCell renderer

Create a custom cell renderer function, to have full control over how a cell looks.

Overview

A renderer is a function that determines how a cell looks.

Set together, a renderer, editor and validator form a cell type.

Declare a custom renderer as a component

Handsontable's React wrapper lets you create custom cell renderers using React components.

To use your component as a Handsontable renderer, pass it in the renderer prop if either HotTable or HotColumn components, as you would with any other config option.

TIP

Handsontable's autoRowSize and autoColumnSize options require calculating the widths/heights of some of the cells before rendering them into the table. For this reason, it's not currently possible to use them alongside component-based renderers, as they're created after the table's initialization.

Be sure to turn those options off in your Handsontable configuration, as keeping them enabled may cause unexpected results. Please note that autoColumnSize is enabled by default.

import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// your renderer component
const RendererComponent = (props) => {
  // the available renderer-related props are:
  // - `row` (row index)
  // - `col` (column index)
  // - `prop` (column property name)
  // - `TD` (the HTML cell element)
  // - `cellProperties` (the `cellProperties` object for the edited cell)
  return (
    <>
      <i style={{ color: '#a9a9a9' }}>
        Row: {props.row}, column: {props.col},
      </i>{' '}
      value: {props.value}
    </>
  );
};

const hotData = [
  ['A1', 'B1', 'C1', 'D1', 'E1'],
  ['A2', 'B2', 'C2', 'D2', 'E2'],
  ['A3', 'B3', 'C3', 'D3', 'E3'],
  ['A4', 'B4', 'C4', 'D4', 'E4'],
  ['A5', 'B5', 'C5', 'D5', 'E5'],
  ['A6', 'B6', 'C6', 'D6', 'E6'],
  ['A7', 'B7', 'C7', 'D7', 'E7'],
  ['A8', 'B8', 'C8', 'D8', 'E8'],
  ['A9', 'B9', 'C9', 'D9', 'E9'],
];

const ExampleComponent = () => {
  return (
    <HotTable
      themeName="ht-theme-main"
      data={hotData}
      autoWrapRow={true}
      autoWrapCol={true}
      autoRowSize={false}
      autoColumnSize={false}
      height="auto"
      licenseKey="non-commercial-and-evaluation"
    >
      <HotColumn width={250} renderer={RendererComponent} />
    </HotTable>
  );
};

export default ExampleComponent;

Use the renderer component within React's Context

In this example, React's Context passes information available in the main app component to the renderer. In this case, we're using just the renderer, but the same principle works with editors as well.

import { useState, useContext, createContext } from 'react';
import { HotTable, HotColumn } from '@handsontable/react-wrapper';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// a component
const HighlightContext = createContext(false);

// a renderer component
function CustomRenderer(props) {
  const darkMode = useContext(HighlightContext);

  if (!props.TD) return;

  if (darkMode) {
    props.TD.className = 'dark';
  } else {
    props.TD.className = '';
  }

  return <div>{props.value}</div>;
}

const ExampleComponent = () => {
  const [darkMode, setDarkMode] = useState(false);
  const toggleDarkMode = (event) => {
    setDarkMode(event.target.checked);
  };

  return (
    <HighlightContext.Provider value={darkMode}>
      <div className="controls">
        <label>
          <input type="checkbox" onClick={toggleDarkMode} /> Dark mode
        </label>
      </div>
      <HotTable
        themeName="ht-theme-main"
        data={[['A1'], ['A2'], ['A3'], ['A4'], ['A5'], ['A6'], ['A7'], ['A8'], ['A9'], ['A10']]}
        rowHeaders={true}
        autoRowSize={false}
        autoColumnSize={false}
        height="auto"
        licenseKey={'non-commercial-and-evaluation'}
      >
        <HotColumn renderer={CustomRenderer} />
      </HotTable>
    </HighlightContext.Provider>
  );
};

export default ExampleComponent;

Declare a custom renderer as a function

You can also declare a custom renderer for the HotTable component by declaring it as a function. In the simplest scenario, you can pass the rendering function as the hotRenderer prop into HotTable or HotColumn. If you need the renderer to be a part of a columns config array, declare it under the renderer key.

The following example implements @handsontable/react-wrapper with a custom renderer added to one of the columns. It takes an image URL as the input and renders the image in the edited cell.

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  return (
    <HotTable
      themeName="ht-theme-main"
      id="hot"
      data={[
        ['A1', 'https://handsontable.com/docs/img/examples/professional-javascript-developers-nicholas-zakas.jpg'],
        ['A2', 'https://handsontable.com/docs/img/examples/javascript-the-good-parts.jpg'],
      ]}
      columns={[
        {},
        {
          renderer(instance, td, row, col, prop, value, cellProperties) {
            const img = document.createElement('img');

            img.src = value;
            img.addEventListener('mousedown', (event) => {
              event.preventDefault();
            });
            td.innerText = '';
            td.appendChild(img);

            return td;
          },
        },
      ]}
      colHeaders={true}
      rowHeights={55}
      height="auto"
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
    />
  );
};

export default ExampleComponent;

TIP

All the sections below describe how to utilize the features available for the Handsontable function-based renderers.

Overview

When you create a renderer, a good idea is to assign it as an alias that will refer to this particular renderer function. Handsontable defines 10 aliases by default:

  • autocomplete for Handsontable.renderers.AutocompleteRenderer
  • base for Handsontable.renderers.BaseRenderer
  • checkbox for Handsontable.renderers.CheckboxRenderer
  • date for Handsontable.renderers.DateRenderer
  • dropdown for Handsontable.renderers.DropdownRenderer
  • html for Handsontable.renderers.HtmlRenderer
  • numeric for Handsontable.renderers.NumericRenderer
  • password for Handsontable.renderers.PasswordRenderer
  • text for Handsontable.renderers.TextRenderer
  • time for Handsontable.renderers.TimeRenderer

It gives users a convenient way for defining which renderer should be used when table rendering was triggered. User doesn't need to know which renderer function is responsible for displaying the cell value, he does not even need to know that there is any function at all. What is more, you can change the render function associated with an alias without a need to change code that defines a table.

TIP

You can set a cell's renderer, editor or validator individually, but you still need to set that cell's type. For example:

renderer: Handsontable.NumericRenderer,
editor: Handsontable.editors.NumericEditor,
validator: Handsontable.NumericValidator,
type: 'numeric',

Use a cell renderer

It is possible to register your renderer and re-use it with the name you registered it under.

<HotTable
  data={someData}
  columns={[
    {
      renderer: "numeric",
    },
  ]}
/>

Register custom cell renderer

To register your own alias use Handsontable.renderers.registerRenderer() function. It takes two arguments:

  • rendererName - a string representing a renderer function
  • renderer - a renderer function that will be represented by rendererName

If you'd like to register asterixDecoratorRenderer under alias asterix you have to call:

Handsontable.renderers.registerRenderer("asterix", asterixDecoratorRenderer);

Choose aliases wisely. If you register your renderer under name that is already registered, the target function will be overwritten:

Handsontable.renderers.registerRenderer("text", asterixDecoratorRenderer);

Now 'text' alias points to asterixDecoratorRenderer function, not Handsontable.renderers.TextRenderer.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your renderer, because you never know aliases has been registered by the user who uses your renderer.

Handsontable.renderers.registerRenderer("asterix", asterixDecoratorRenderer);

Someone might already registered such alias

Handsontable.renderers.registerRenderer("my.asterix", asterixDecoratorRenderer);

That's better.

Use an alias

The final touch is to use registered aliases. That way users can easily refer to an alias without the need to know the name of the function.

To sum up, a well prepared renderer function should look like this:

function customRenderer(
  hotInstance,
  td,
  row,
  column,
  prop,
  value,
  cellProperties
) {
  // Optionally include `BaseRenderer` which is responsible for
  // adding/removing CSS classes to/from the table cells.
  Handsontable.renderers.BaseRenderer.apply(this, arguments);

  // ...your custom logic of the renderer
}

// Register an alias
Handsontable.renderers.registerRenderer("my.custom", customRenderer);

From now on, you can use customRenderer like so:

<HotTable
  data={someData}
  columns={[
    {
      renderer: "my.custom",
    },
  ]}
/>

Render custom HTML in cells

This example shows how to use custom cell renderers to display HTML content in a cell. This is a very powerful feature. Just remember to escape any HTML code that could be used for XSS attacks. In the below configuration:

  • Title column uses built-in HTML renderer that allows any HTML. This is unsafe if your code comes from untrusted source. Take notice that a Handsontable user can use it to enter <script> or other potentially malicious tags using the cell editor!
  • Description column also uses HTML renderer (same as above)
  • Comments column uses a custom renderer (safeHtmlRenderer). This should be safe for user input, because only certain tags are allowed
  • Cover column accepts image URL as a string and converts it to a <img> in the renderer

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const data = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      comments: 'I would rate it ★★★★☆',
      cover: 'https://handsontable.com/docs/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
    },
    {
      title: '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      comments: 'This is the book about JavaScript',
      cover: 'https://handsontable.com/docs/img/examples/javascript-the-good-parts.jpg',
    },
    {
      title: '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      comments:
        'I\'ve never actually read it, but the <a href="https://shop.oreilly.com/product/9780596805531.do">comments</a> are highly <strong>positive</strong>.',
      cover: 'https://handsontable.com/docs/img/examples/javascript-the-definitive-guide.jpg',
    },
  ];

  function safeHtmlRenderer(_instance, td, _row, _col, _prop, value, _cellProperties) {
    // WARNING: Be sure you only allow certain HTML tags to avoid XSS threats.
    // Sanitize the "value" before passing it to the innerHTML property.
    td.innerHTML = value;
  }

  function coverRenderer(_instance, td, _row, _col, _prop, value, _cellProperties) {
    const img = document.createElement('img');

    img.src = value;
    img.addEventListener('mousedown', (event) => {
      event.preventDefault();
    });
    td.innerText = '';
    td.appendChild(img);

    return td;
  }

  return (
    <HotTable
      themeName="ht-theme-main"
      data={data}
      colWidths={[200, 200, 200, 80]}
      colHeaders={['Title', 'Description', 'Comments', 'Cover']}
      height="auto"
      columns={[
        { data: 'title', renderer: 'html' },
        { data: 'description', renderer: 'html' },
        { data: 'comments', renderer: safeHtmlRenderer },
        { data: 'cover', renderer: coverRenderer },
      ]}
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
    />
  );
};

export default ExampleComponent;

Render custom HTML in header

You can also put HTML into row and column headers. If you need to attach events to DOM elements like the checkbox below, just remember to identify the element by class name, not by id. This is because row and column headers are duplicated in the DOM tree and id attribute must be unique.

import { useRef } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { textRenderer } from 'handsontable/renderers/textRenderer';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();

const ExampleComponent = () => {
  const hotRef = useRef(null);
  let isChecked = false;

  function customRenderer(_instance, td) {
    textRenderer.apply(this, arguments);

    if (isChecked) {
      td.style.backgroundColor = 'yellow';
    } else {
      td.style.backgroundColor = 'rgba(255,255,255,0.1)';
    }
  }

  const exampleContainerMouseupCallback = (event) => {
    const hot = hotRef.current?.hotInstance;

    if (event.target.nodeName == 'INPUT' && event.target.className == 'checker') {
      isChecked = !event.target.checked;
      hot?.render();
    }
  };

  return (
    <div id="exampleContainer5" onMouseUp={(...args) => exampleContainerMouseupCallback(...args)}>
      <HotTable
        themeName="ht-theme-main"
        ref={hotRef}
        height="auto"
        columns={[{}, { renderer: customRenderer }]}
        colHeaders={function (col) {
          switch (col) {
            case 0:
              return '<b>Bold</b> and <em>Beautiful</em>';
            case 1:
              return `Some <input type="checkbox" class="checker" ${isChecked ? `checked="checked"` : ''}> checkbox`;
            default:
              return '';
          }
        }}
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </div>
  );
};

export default ExampleComponent;

Add event listeners in cell renderer function

If you are writing an advanced cell renderer, and you want to add some custom behavior after a certain user action (i.e. after user hover a mouse pointer over a cell) you might be tempted to add an event listener directly to table cell node passed as an argument to the renderer function. Unfortunately, this will almost always cause you trouble and you will end up with either performance issues or having the listeners attached to the wrong cell.

This is because Handsontable:

  • Calls renderer functions multiple times per cell - this can lead to having multiple copies of the same event listener attached to a cell
  • Reuses table cell nodes during table scrolling and adding/removing new rows/columns - this can lead to having event listeners attached to the wrong cell

Before deciding to attach an event listener in cell renderer make sure, that there is no Handsontable event that suits your needs. Using Handsontable events system is the safest way to respond to user actions.

If you did't find a suitable Handsontable event put the cell content into a wrapping <div>, attach the event listener to the wrapper and then put it into the table cell.

Performance considerations

Cell renderers are called separately for every displayed cell, during every table render. Table can be rendered multiple times during its lifetime (after table scroll, after table sorting, after cell edit etc.), therefore you should keep your renderer functions as simple and fast as possible or you might experience a performance drop, especially when dealing with large sets of data.

Angular Data GridCell renderer

Create a custom cell renderer function, to have full control over how a cell looks.

Overview

A renderer is a function that determines how a cell looks.

Set together, a renderer, editor and validator form a cell type.

Declare a custom renderer as a component

Handsontable's Angular wrapper lets you create custom cell renderers using Angular components. To do so, create a component that extends the base renderer class HotCellRendererComponent.

In the Angular wrapper for Handsontable, a renderer can be provided either as an Angular component or as a function. To use your component as a Handsontable renderer, pass it in the renderer prop to the HotTableComponent, as you would with any other config option.

TIP

Handsontable's autoRowSize and autoColumnSize options require calculating the widths/heights of some of the cells before rendering them into the table. For this reason, it's not currently possible to use them alongside component-based renderers, as they're created after the table's initialization.

Be sure to turn those options off in your Handsontable configuration, as keeping them enabled may cause unexpected results. Please note that autoColumnSize is enabled by default.

/* file: app.component.ts */
import {AfterViewInit, ChangeDetectionStrategy, Component, OnInit, ViewChild} from '@angular/core';
import {GridSettings, HotCellRendererComponent, HotTableComponent} from '@handsontable/angular-wrapper';

@Component({
  selector: 'app-cover-renderer',
  changeDetection: ChangeDetectionStrategy.OnPush,
  template: `<img [src]="value" (mousedown)="$event.preventDefault()"/>`,
  standalone: false,
})
export class CoverRendererComponent extends HotCellRendererComponent<string> {
}


@Component({
  selector: 'app-example1',
  template: `
    <hot-table *ngIf="!!hotSettings"
               [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent implements OnInit, AfterViewInit {
  @ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;

  readonly hotData = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      cover:
        'https://handsontable.com/docs/15.0/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-good-parts.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-definitive-guide.jpg',
    },
  ];

  hotSettings!: GridSettings;

  ngOnInit() {
  }

  ngAfterViewInit() {
    this.hotSettings = {
      colWidths: [200, 400, 80],
      colHeaders: ['Title', 'Description', 'Cover'],
      height: 'auto',
      columns: [
        { data: 'title', renderer: 'html' },
        { data: 'description', renderer: 'html' },
        { data: 'cover', renderer: CoverRendererComponent },
      ],
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent, CoverRendererComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent, CoverRendererComponent  ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

You can create and use a custom cell renderer component that utilizes the rendererProps property and use them inside the renderer component.

/* file: app.component.ts */
import {ChangeDetectionStrategy, Component, OnInit} from '@angular/core';
import {GridSettings, HotCellRendererComponent} from '@handsontable/angular-wrapper';

@Component({
  selector: 'app-color-renderer',
  template: `<span [style.color]="textColor">{{value}}</span>`,
  standalone: true,
  changeDetection: ChangeDetectionStrategy.OnPush
})
export class ColorRendererComponent extends HotCellRendererComponent<string, {
  textColor?: string,
  textColorFn?: (value: string) => string
}> implements OnInit {
  textColor = '';

  ngOnInit() {
    const props = this.getProps();
    this.textColor = props.textColor ?? 'black';

    if (props.textColorFn && typeof props.textColorFn === 'function') {
      this.textColor = props.textColorFn(this.value);
    }
  }

}

@Component({
  selector: 'app-example3',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent {

  readonly hotData = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      rate: 3
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      rate: 9
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      rate: 5
    },
  ];

  readonly hotSettings: GridSettings = {
    colWidths: [200, 400, 80],
    colHeaders: ['Title', 'Description', 'Comments', 'Cover'],
    height: 'auto',
    columns: [
      { data: 'title', renderer: ColorRendererComponent, rendererProps: { textColor: 'blue' } },
      { data: 'description', renderer: ColorRendererComponent, rendererProps: { textColor: 'orange' } },
      { data: 'rate', renderer: ColorRendererComponent, rendererProps: { textColorFn: (value: string) => +value <= 5 ? 'red' : 'inherit' } },
    ],
    autoWrapRow: true,
    autoWrapCol: true,
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Declare a custom renderer as an Angular Template

The Angular wrapper supports using an Angular TemplateRef as a renderer. This is particularly useful if you want to leverage the power of Angular templates directly, without creating a full component.

/* file: app.component.ts */
import {Component, OnInit, TemplateRef, ViewChild} from '@angular/core';
import {GridSettings} from '@handsontable/angular-wrapper';

@Component({
  selector: 'app-example2',
  template: `
    <hot-table
      [settings]="hotSettings!" [data]="hotData">
    </hot-table>

    <ng-template #coverRenderer let-value>
      <img [src]="value" (mousedown)="$event.preventDefault()"/>
    </ng-template>
  `,
  standalone: false
})
export class AppComponent implements OnInit {
  @ViewChild('coverRenderer', { static: true }) coverRendererTemplate!: TemplateRef<any>;

  readonly hotData = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      cover:
        'https://handsontable.com/docs/15.0/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-good-parts.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-definitive-guide.jpg',
    },
  ];

  hotSettings!: GridSettings;

  ngOnInit() {
    this.hotSettings = {
      colWidths: [200, 400, 80],
      colHeaders: ['Title', 'Description', 'Cover'],
      height: 'auto',
      columns: [
        { data: 'title', renderer: 'html' },
        { data: 'description', renderer: 'html' },
        { data: 'cover', renderer: this.coverRendererTemplate },
      ],
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Declare a custom renderer as a function

You can also declare a custom renderer for the HotTable component by declaring it as a function. In the simplest scenario, you can pass the rendering function as the renderer prop into HotTableComponent.

The following example implements @handsontable/angular-wrapper with a custom renderer added to one of the columns. It takes an image URL as the input and renders the image in the edited cell.

/* file: app.component.ts */
import {AfterViewInit, Component, OnInit} from '@angular/core';
import {GridSettings} from '@handsontable/angular-wrapper';

const coverRenderer = (_instance, td, _row, _col, _prop, value) => {
  const img = document.createElement('img');

  img.src = value;
  img.addEventListener('mousedown', (event) => {
    event.preventDefault();
  });
  td.innerText = '';
  td.appendChild(img);

  return td;
};


@Component({
  selector: 'app-example4',
  template: `
    <hot-table *ngIf="!!hotSettings"
               [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent implements OnInit, AfterViewInit {

  readonly hotData = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      cover:
        'https://handsontable.com/docs/15.0/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-good-parts.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      cover: 'https://handsontable.com/docs/15.0/img/examples/javascript-the-definitive-guide.jpg',
    },
  ];

  hotSettings!: GridSettings;

  ngOnInit() {
  }

  ngAfterViewInit() {
    this.hotSettings = {
      colWidths: [200, 400, 80],
      colHeaders: ['Title', 'Description', 'Cover'],
      height: 'auto',
      columns: [
        { data: 'title', renderer: 'html' },
        { data: 'description', renderer: 'html' },
        { data: 'cover', renderer: coverRenderer },
      ],
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent  ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

TIP

All the sections below describe how to utilize the features available for the Handsontable function-based renderers.

Overview

When you create a renderer, a good idea is to assign it as an alias that will refer to this particular renderer function. Handsontable defines 10 aliases by default:

  • autocomplete for Handsontable.renderers.AutocompleteRenderer
  • base for Handsontable.renderers.BaseRenderer
  • checkbox for Handsontable.renderers.CheckboxRenderer
  • date for Handsontable.renderers.DateRenderer
  • dropdown for Handsontable.renderers.DropdownRenderer
  • html for Handsontable.renderers.HtmlRenderer
  • numeric for Handsontable.renderers.NumericRenderer
  • password for Handsontable.renderers.PasswordRenderer
  • text for Handsontable.renderers.TextRenderer
  • time for Handsontable.renderers.TimeRenderer

It gives users a convenient way for defining which renderer should be used when table rendering was triggered. User doesn't need to know which renderer function is responsible for displaying the cell value, he does not even need to know that there is any function at all. What is more, you can change the render function associated with an alias without a need to change code that defines a table.

TIP

You can set a cell's renderer, editor or validator individually, but you still need to set that cell's type. For example:

renderer: Handsontable.NumericRenderer,
editor: Handsontable.editors.NumericEditor,
validator: Handsontable.NumericValidator,
type: 'numeric',

Use a cell renderer

It is possible to register your renderer and re-use it with the name you registered it under.

import { GridSettings, HotTableModule } from "@handsontable/angular-wrapper";

const data = someData;
const configurationOptions: GridSettings = {
  columns: [
    {
      renderer: "numeric",
    },
  ],
};
<hot-table [data]="data" [settings]="configurationOptions"></hot-table>

Register custom cell renderer

To register your own alias use Handsontable.renderers.registerRenderer() function. It takes two arguments:

  • rendererName - a string representing a renderer function
  • renderer - a renderer function that will be represented by rendererName

If you'd like to register asterixDecoratorRenderer under alias asterix you have to call:

Handsontable.renderers.registerRenderer("asterix", asterixDecoratorRenderer);

Choose aliases wisely. If you register your renderer under name that is already registered, the target function will be overwritten:

Handsontable.renderers.registerRenderer("text", asterixDecoratorRenderer);

Now 'text' alias points to asterixDecoratorRenderer function, not Handsontable.renderers.TextRenderer.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your renderer, because you never know aliases has been registered by the user who uses your renderer.

Handsontable.renderers.registerRenderer("asterix", asterixDecoratorRenderer);

Someone might already registered such alias

Handsontable.renderers.registerRenderer("my.asterix", asterixDecoratorRenderer);

That's better.

Use an alias

The final touch is to use registered aliases. That way users can easily refer to an alias without the need to know the name of the function.

To sum up, a well prepared renderer function should look like this:

function customRenderer(
  hotInstance,
  td,
  row,
  column,
  prop,
  value,
  cellProperties
) {
  // Optionally include `BaseRenderer` which is responsible for
  // adding/removing CSS classes to/from the table cells.
  Handsontable.renderers.BaseRenderer.apply(this, arguments);

  // ...your custom logic of the renderer
}

// Register an alias
Handsontable.renderers.registerRenderer("my.custom", customRenderer);

From now on, you can use customRenderer like so:

import { GridSettings, HotTableModule } from "@handsontable/angular-wrapper";

const data = someData;
const configurationOptions: GridSettings = {
  columns: [
    {
      renderer: "my.custom",
    },
  ],
};
<hot-table [data]="data" [settings]="configurationOptions"></hot-table>

Render custom HTML in cells

This example shows how to use custom cell renderers to display HTML content in a cell. This is a very powerful feature. Just remember to escape any HTML code that could be used for XSS attacks. In the below configuration:

  • Title column uses built-in HTML renderer that allows any HTML. This is unsafe if your code comes from untrusted source. Take notice that a Handsontable user can use it to enter <script> or other potentially malicious tags using the cell editor!
  • Description column also uses HTML renderer (same as above)
  • Comments column uses a custom renderer (safeHtmlRenderer). This should be safe for user input, because only certain tags are allowed
  • Cover column accepts image URL as a string and converts it to a <img> in the renderer

/* file: app.component.ts */
import {AfterViewInit, Component} from '@angular/core';
import {GridSettings} from '@handsontable/angular-wrapper';

function safeHtmlRenderer(
  _instance,
  td,
  _row,
  _col,
  _prop,
  value,
  _cellProperties
) {
  // WARNING: Be sure you only allow certain HTML tags to avoid XSS threats.
  // Sanitize the "value" before passing it to the innerHTML property.
  td.innerHTML = value;
  return td;
}

function coverRenderer(
  _instance,
  td,
  _row,
  _col,
  _prop,
  value,
  _cellProperties
) {
  const img = document.createElement('img');

  img.src = value;
  img.addEventListener('mousedown', (event) => {
    event.preventDefault();
  });
  td.innerText = '';
  td.appendChild(img);

  return td;
}

@Component({
  selector: 'app-example5',
  template: `
    <hot-table *ngIf="hotSettings"
               [settings]="hotSettings!" [data]="hotData">
    </hot-table>
  `,
  standalone: false
})
export class AppComponent implements AfterViewInit {

  readonly hotData = [
    {
      title:
        '<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
      description:
        'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
      comments: 'I would rate it ★★★★☆',
      cover:
        'http://localhost:8080/docs/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
      description:
        'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
      comments: 'This is the book about JavaScript',
      cover: 'http://localhost:8080/docs/img/examples/javascript-the-good-parts.jpg',
    },
    {
      title:
        '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
      description:
        '<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
      comments:
        'I\'ve never actually read it, but the <a href="https://shop.oreilly.com/product/9780596805531.do">comments</a> are highly <strong>positive</strong>.',
      cover: 'http://localhost:8080/docs/img/examples/javascript-the-definitive-guide.jpg',
    }
  ];

  hotSettings!: GridSettings;

  ngAfterViewInit() {
    this.hotSettings = {
      colWidths: [200, 200, 200, 80],
      colHeaders: ['Title', 'Description', 'Comments', 'Cover'],
      height: 'auto',
      columns: [
        { data: 'title', renderer: 'html' },
        { data: 'description', renderer: 'html' },
        { data: 'comments', renderer: safeHtmlRenderer },
        { data: 'cover', renderer: coverRenderer },
      ],
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent  ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Render custom HTML in header

You can also put HTML into row and column headers. If you need to attach events to DOM elements like the checkbox below, just remember to identify the element by class name, not by id. This is because row and column headers are duplicated in the DOM tree and id attribute must be unique.

/* file: app.component.ts */
import {AfterViewInit, Component, ViewChild} from '@angular/core';
import {GridSettings, HotTableComponent} from '@handsontable/angular-wrapper';
import { textRenderer } from 'handsontable/renderers/textRenderer';

@Component({
  selector: 'app-example6',
  template: `

    <div
      id="exampleContainer5"
      (mouseup)="exampleContainerMouseupCallback($event)"
    >
      <hot-table *ngIf="!!hotSettings"
                 [settings]="hotSettings!">
      </hot-table>
    </div>
  `,
  standalone: false
})
export class AppComponent implements AfterViewInit {
  @ViewChild(HotTableComponent, {static: false}) hotTable!: HotTableComponent;

  isChecked = false;

  hotSettings!: GridSettings;

  ngAfterViewInit() {
    const componentThis = this;

    function customRenderer(_instance, td) {
      textRenderer.apply(componentThis, arguments);

      if (componentThis.isChecked) {
        td.style.backgroundColor = 'yellow';
      } else {
        td.style.backgroundColor = 'rgba(255,255,255,0.1)';
      }
    }

    this.hotSettings = {
      height: 'auto',
      columns: [{}, { renderer: customRenderer }],
      colHeaders(col) {
        return col === 0
          ? '<b>Bold</b> and <em>Beautiful</em>'
          : `Some <input type="checkbox" class="checker" ${
            componentThis.isChecked ? 'checked="checked"' : ''
          }> checkbox`;
      },
      autoWrapRow: true,
      autoWrapCol: true,
    };
  }

  exampleContainerMouseupCallback = (event) => {
    const hot = this.hotTable.hotInstance!;

    if (
      event.target?.nodeName == 'INPUT' &&
      event.target.className == 'checker'
    ) {
      this.isChecked = !event.target.checked;
      hot?.render();
    }
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';

import { AppComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ AppComponent  ],
  providers: [...appConfig.providers],
  bootstrap: [ AppComponent ]
})

export class AppModule { }

Add event listeners in cell renderer function

If you are writing an advanced cell renderer, and you want to add some custom behavior after a certain user action (i.e. after user hover a mouse pointer over a cell) you might be tempted to add an event listener directly to table cell node passed as an argument to the renderer function. Unfortunately, this will almost always cause you trouble and you will end up with either performance issues or having the listeners attached to the wrong cell.

This is because Handsontable:

  • Calls renderer functions multiple times per cell - this can lead to having multiple copies of the same event listener attached to a cell
  • Reuses table cell nodes during table scrolling and adding/removing new rows/columns - this can lead to having event listeners attached to the wrong cell

Before deciding to attach an event listener in cell renderer make sure, that there is no Handsontable event that suits your needs. Using Handsontable events system is the safest way to respond to user actions.

If you did't find a suitable Handsontable event put the cell content into a wrapping <div>, attach the event listener to the wrapper and then put it into the table cell.

Performance considerations

Cell renderers are called separately for every displayed cell, during every table render. Table can be rendered multiple times during its lifetime (after table scroll, after table sorting, after cell edit etc.), therefore you should keep your renderer functions as simple and fast as possible or you might experience a performance drop, especially when dealing with large sets of data.

Skip to content

Cell renderer

A cell renderer is a function that controls how cell content is displayed in the DOM. Override a built-in renderer or write your own to customize the visual output.

Use a cell renderer

You can use any of the built-in renderers by specifying their alias name in your column configuration. The example below shows how to use the numeric renderer, which formats numeric values according to the cell’s formatting options:

<HotTable :settings="{ columns: [{ renderer: 'numeric' }] }" />

Declare a custom renderer as a component

Handsontable’s Vue wrapper lets you create custom cell renderers using Vue components.

To use a Vue component as a renderer, define the component with defineComponent, then write a renderer function that mounts it into the cell td element with Vue’s render and h helpers. Mounting with render(h(Component, props), td) reuses the same component instance across re-renders β€” Vue patches the existing tree instead of remounting it. To pass static props alongside the cell data, merge them into the second argument of h().

Vue
<script setup lang="ts">
import { ref, h, render, defineComponent } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
import type { BaseRenderer } from 'handsontable/renderers';
registerAllModules();
// A small Vue component used as a cell renderer.
const CellDisplay = defineComponent({
props: {
row: { type: Number, required: true },
col: { type: Number, required: true },
value: { type: String, default: '' },
},
render() {
return h('span', [
h('i', { style: 'color:#a9a9a9' }, `Row: ${this.row}, column: ${this.col},`),
' value: ',
h('strong', this.value),
]);
},
});
const componentRenderer: BaseRenderer = (instance, td, row, col, _prop, value) => {
render(h(CellDisplay, { row, col, value: String(value) }), td);
return td;
};
const hotSettings = ref<GridSettings>({
data: [
['Mercedes A 160', 'Q1 2024', '7 200'],
['Citroen C4 Coupe', 'Q2 2024', '8 330'],
['Audi A4 Avant', 'Q3 2024', '33 900'],
['Opel Astra', 'Q4 2024', '5 000'],
['BMW 320i Coupe', 'Q1 2025', '30 500'],
],
colHeaders: ['Model', 'Quarter', 'Price (EUR)'],
columns: [
{ renderer: componentRenderer },
{ renderer: componentRenderer },
{ renderer: componentRenderer },
],
colWidths: 250,
autoRowSize: false,
autoColumnSize: false,
height: 'auto',
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

If your component needs access to a Vue application context β€” for example, global components, plugins, or provide / inject β€” use createApp(Component, props).mount(td) instead of render(). Store a reference to the mounted app on the td element and call app.unmount() at the start of each render call to avoid leaking app instances:

Vue
<script setup lang="ts">
import { ref, h, createApp, defineComponent, inject } from 'vue';
import type { App } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
import type { BaseRenderer } from 'handsontable/renderers';
registerAllModules();
// A component that reads an injected currency formatter via inject().
// inject() requires a Vue app context -- use createApp() to provide it.
const RevenueCell = defineComponent({
props: { value: { type: String, default: '' } },
setup(props) {
const format = inject<(v: string) => string>('formatRevenue', (v) => v);
return () => h('span', format(props.value));
},
});
type TdWithApp = HTMLTableCellElement & { _app?: App };
const revenueRenderer: BaseRenderer = (_instance, td, _row, _col, _prop, value) => {
const cell = td as TdWithApp;
// Unmount the previous app on this cell before remounting.
cell._app?.unmount();
const app = createApp(RevenueCell, { value: String(value) });
app.provide('formatRevenue', (v: string) => {
const num = parseFloat(v);
return isNaN(num)
? v
: new Intl.NumberFormat('en-US', { style: 'currency', currency: 'USD' }).format(num);
});
cell._app = app;
app.mount(td);
return td;
};
const hotSettings = ref<GridSettings>({
data: [
['Acme Corp', 'Q1 2025', '42000'],
['Vertex Industries', 'Q2 2025', '18750.5'],
['Harbor Goods', 'Q3 2025', '9200'],
['Alpine Supply Co.', 'Q4 2025', '130000'],
['Pinnacle Ltd', 'Q1 2026', '67450.25'],
],
colHeaders: ['Company', 'Quarter', 'Revenue'],
columns: [
{},
{},
{ renderer: revenueRenderer },
],
height: 'auto',
stretchH: 'all',
autoRowSize: false,
autoColumnSize: false,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example2">
<HotTable :settings="hotSettings" />
</div>
</template>

Register custom cell renderer

To register your own alias use registerRenderer() function from the @handsontable/renderers package. It takes two arguments:

  • rendererName - a string representing a renderer function
  • renderer - a renderer function that will be represented by rendererName

If you’d like to register asteriskDecoratorRenderer under alias asterisk you have to call:

import { registerRenderer } from "@handsontable/renderers";
registerRenderer("asterisk", asteriskDecoratorRenderer);

Choose aliases wisely. If you register your renderer under name that is already registered, the target function will be overwritten:

import { registerRenderer } from "@handsontable/renderers";
registerRenderer("text", asteriskDecoratorRenderer);

Now "text" alias points to asteriskDecoratorRenderer function, not the built-in textRenderer.

So, unless you intentionally want to overwrite an existing alias, try to choose a unique name. A good practice is prefixing your aliases with some custom name (for example your GitHub username) to minimize the possibility of name collisions. This is especially important if you want to publish your renderer, because you never know aliases has been registered by the user who uses your renderer.

import { registerRenderer } from "@handsontable/renderers";
registerRenderer("asterisk", asteriskDecoratorRenderer);

Someone might already registered such alias

import { registerRenderer } from "@handsontable/renderers";
registerRenderer("my.asterisk", asteriskDecoratorRenderer);

That’s better.

Use an alias

The final touch is to use registered aliases. That way users can easily refer to an alias without the need to know the name of the function.

To sum up, a well prepared renderer function should look like this:

import { registerRenderer } from "@handsontable/renderers";
function customRenderer(
hotInstance,
td,
row,
column,
prop,
value,
cellProperties
) {
// ...your custom logic of the renderer
}
// Register an alias
registerRenderer("my.custom", customRenderer);

From now on, you can use customRenderer like so:

<HotTable :settings="{ columns: [{ renderer: 'my.custom' }] }" />

Render custom HTML in cells

This example shows how to use custom cell renderers to display HTML content in a cell. This is a very powerful feature. Just remember to escape any HTML code that could be used for XSS attacks.

In the below configuration:

  • Title column uses built-in HTML renderer that allows any HTML. This is unsafe if your data comes from an untrusted source. A Handsontable user can enter <script> or other potentially malicious tags using the cell editor.
  • Description column also uses HTML renderer (same as above)
  • Comments column uses a custom renderer (safeHtmlRenderer). This should be safe for user input, because only certain tags are allowed
  • Cover column accepts image URL as a string and converts it to a <img> in the renderer
Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
import type { BaseRenderer } from 'handsontable/renderers';
registerAllModules();
interface Book {
title: string;
description: string;
comments: string;
cover: string;
}
const data: Book[] = [
{
title:
'<a href="https://www.amazon.com/Professional-JavaScript-Developers-Nicholas-Zakas/dp/1118026691">Professional JavaScript for Web Developers</a>',
description:
'This <a href="https://bit.ly/sM1bDf">book</a> provides a developer-level introduction along with more advanced and useful features of <b>JavaScript</b>.',
comments: 'I would rate it &#x2605;&#x2605;&#x2605;&#x2605;&#x2606;',
cover: '/docs/img/examples/professional-javascript-developers-nicholas-zakas.jpg',
},
{
title: '<a href="https://shop.oreilly.com/product/9780596517748.do">JavaScript: The Good Parts</a>',
description:
'This book provides a developer-level introduction along with <b>more advanced</b> and useful features of JavaScript.',
comments: 'This is the book about JavaScript',
cover: '/docs/img/examples/javascript-the-good-parts.jpg',
},
{
title: '<a href="https://shop.oreilly.com/product/9780596805531.do">JavaScript: The Definitive Guide</a>',
description:
'<em>JavaScript: The Definitive Guide</em> provides a thorough description of the core <b>JavaScript</b> language and both the legacy and standard DOMs implemented in web browsers.',
comments:
'I\'ve never actually read it, but the <a href="https://shop.oreilly.com/product/9780596805531.do">comments</a> are highly <strong>positive</strong>.',
cover: '/docs/img/examples/javascript-the-definitive-guide.jpg',
},
];
const safeHtmlRenderer: BaseRenderer = (_instance, td, _row, _col, _prop, value) => {
// WARNING: Be sure you only allow certain HTML tags to avoid XSS threats.
// Sanitize the "value" before passing it to the innerHTML property.
td.innerHTML = value as string;
};
const coverRenderer: BaseRenderer = (_instance, td, _row, _col, _prop, value) => {
const img = document.createElement('img');
img.src = value as string;
img.addEventListener('mousedown', (event) => {
event.preventDefault();
});
td.innerText = '';
td.appendChild(img);
return td;
};
const hotSettings = ref<GridSettings>({
data,
colWidths: [200, 200, 200, 80],
colHeaders: ['Title', 'Description', 'Comments', 'Cover'],
height: 'auto',
columns: [
{ data: 'title', renderer: 'html' },
{ data: 'description', renderer: 'html' },
{ data: 'comments', renderer: safeHtmlRenderer },
{ data: 'cover', renderer: coverRenderer },
],
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example4">
<HotTable :settings="hotSettings" />
</div>
</template>

Render custom HTML in header

You can also put HTML into row and column headers. If you need to attach events to DOM elements like the checkbox below, just remember to identify the element by class name, not by id. This is because row and column headers are duplicated in the DOM tree and id attribute must be unique.

Vue
<script setup lang="ts">
import { ref, useTemplateRef } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import type { GridSettings } from 'handsontable/settings';
import type { BaseRenderer } from 'handsontable/renderers';
import { textRenderer } from 'handsontable/renderers/textRenderer';
registerAllModules();
const ALLOWED_TAGS = ['B', 'EM', 'INPUT', 'BR', 'TABLE', 'THEAD', 'TBODY', 'TR', 'TD', 'TH'];
const ALLOWED_ATTRIBUTES = ['type', 'class', 'checked', 'colspan', 'rowspan'];
const DROPPED_TAGS = ['SCRIPT', 'STYLE', 'TEXTAREA', 'TITLE'];
// Handsontable has no built-in sanitizer since v18.0, and `sanitizer` is grid-level:
// it also filters pasted HTML, so the table tags have to survive -- otherwise pasting
// a range degrades to plain text. In production, use a vetted library such as DOMPurify.
// See https://handsontable.com/docs/security/
const sanitizeHeader = (html: string): string => {
const template = document.createElement('template');
template.innerHTML = html;
template.content.querySelectorAll('*').forEach((element) => {
if (DROPPED_TAGS.includes(element.tagName)) {
// Unwrapping these would promote their source text into the output
element.remove();
} else if (ALLOWED_TAGS.includes(element.tagName)) {
Array.from(element.attributes).forEach((attribute) => {
if (!ALLOWED_ATTRIBUTES.includes(attribute.name)) {
element.removeAttribute(attribute.name);
}
});
} else {
// Unwrap a disallowed element, keeping its text content
element.replaceWith(...Array.from(element.childNodes));
}
});
return template.innerHTML;
};
const hotRef = useTemplateRef<InstanceType<typeof HotTable>>('hotRef');
const isChecked = ref(false);
const customRenderer: BaseRenderer = (instance, td, row, col, prop, value, cellProperties) => {
textRenderer(instance, td, row, col, prop, value, cellProperties);
if (isChecked.value) {
td.style.backgroundColor = 'yellow';
} else {
td.style.backgroundColor = 'rgba(255,255,255,0.1)';
}
};
const hotSettings = ref<GridSettings>({
height: 'auto',
columns: [{}, { renderer: customRenderer }],
colHeaders(col: number) {
return col === 0
? '<b>Bold</b> and <em>Beautiful</em>'
: `Some <input type="checkbox" class="checker" ${isChecked.value ? 'checked="checked"' : ''}> checkbox`;
},
sanitizer: sanitizeHeader,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
function onContainerMousedown(event: MouseEvent) {
const target = event.target as HTMLElement;
if (target.nodeName === 'INPUT' && target.className === 'checker') {
event.stopPropagation();
}
}
function onContainerMouseup(event: MouseEvent) {
const target = event.target as HTMLElement;
if (target.nodeName === 'INPUT' && target.className === 'checker') {
isChecked.value = !(target as HTMLInputElement).checked;
hotRef.value?.hotInstance?.render();
}
}
</script>
<template>
<div id="example5">
<div id="exampleContainer5" @mousedown="onContainerMousedown" @mouseup="onContainerMouseup">
<HotTable ref="hotRef" :settings="hotSettings" />
</div>
</div>
</template>

Add event listeners in cell renderer function

If you are writing an advanced cell renderer, and you want to add some custom behavior after a certain user action (i.e. after user hover a mouse pointer over a cell) you might be tempted to add an event listener directly to table cell node passed as an argument to the renderer function. Unfortunately, this will almost always cause you trouble and you will end up with either performance issues or having the listeners attached to the wrong cell.

This is because Handsontable:

  • Calls renderer functions multiple times per cell - this can lead to having multiple copies of the same event listener attached to a cell
  • Reuses table cell nodes during table scrolling and adding/removing new rows/columns - this can lead to having event listeners attached to the wrong cell

Before deciding to attach an event listener in cell renderer make sure, that there is no Handsontable event that suits your needs. Using Handsontable events system is the safest way to respond to user actions.

If you did’t find a suitable Handsontable event put the cell content into a wrapping <div>, attach the event listener to the wrapper and then put it into the table cell.

Performance considerations

Cell renderers are called separately for every displayed cell, during every table render. Table can be rendered multiple times during its lifetime (after table scroll, after table sorting, after cell edit etc.), therefore you should keep your renderer functions as simple and fast as possible or you might experience a performance drop, especially when dealing with large sets of data.

If you only need to format the displayed value (e.g., add units, format dates, or apply text transformations), consider using the valueFormatter option instead of a custom renderer. The valueFormatter is called before the renderer and focuses solely on value transformation, making it more performant for simple formatting tasks. Use a renderer when you need to modify the DOM structure, add custom HTML elements, or handle complex visual layouts.

Overview

A renderer is a function that determines how a cell looks. It’s responsible for the complete cell rendering process, including DOM structure creation, content insertion, applying CSS classes, setting accessibility attributes, and managing all visual aspects of the cell.

Built-in renderers

Handsontable provides 10 built-in renderers that you can use by their alias names. Each renderer is designed for a specific use case:

AliasWhat the renderer does
autocompleteRenders autocomplete cells with suggestions
checkboxRenders checkbox cells for boolean values or values defined by checkedTemplate and uncheckedTemplate options
dateRenders date values with date formatting
dropdownRenders dropdown cells with select options
htmlRenders HTML content in cells (allows raw HTML)
numericRenders numeric values with number formatting
passwordRenders password fields (masks the displayed value)
textRenders plain text (default renderer)
timeRenders time values with time formatting

Using aliases provides a convenient way to specify which renderer should be used without needing to reference the full renderer function. You can change the renderer function associated with an alias without modifying the code that uses it.

renderer vs valueFormatter

Handsontable provides two distinct options for controlling how cell values are displayed: valueFormatter and renderer. This section provides a detailed comparison to help you choose the right tool for your use case.

What is renderer?

The renderer option is a function responsible for the complete cell rendering process. It handles DOM structure creation, content insertion (via innerText or innerHTML), applying CSS classes, setting accessibility attributes, and managing all visual aspects of the cell.

Function signature:

renderer(hotInstance, td, row, col, prop, value, cellProperties)

When to use renderer:

  • Modify DOM structure (add icons, custom HTML elements, complex layouts)
  • Apply custom styling or CSS classes dynamically
  • Handle accessibility attributes
  • Create interactive elements within cells
  • When you need full control over the cell’s HTML structure

Example:

function customRenderer(hotInstance, td, row, col, prop, value, cellProperties) {
// Create custom DOM structure
td.innerHTML = `
<div class="custom-wrapper">
<span class="icon">πŸ“Š</span>
<span class="value">${value}</span>
</div>
`;
}

What is valueFormatter?

The valueFormatter option (available since v17.0.0) is a function that transforms cell values before they are displayed. It focuses solely on value transformation and is called by the rendering engine right before the renderer function executes.

Function signature:

valueFormatter(value, cellProperties) => formattedValue

When to use valueFormatter:

  • Transform displayed values (add prefix, suffix, units)
  • Format dates, numbers, or text in a custom way
  • Apply simple text transformations
  • When you only need to change what is displayed, not how it’s rendered

Example:

<HotTable :settings="{
columns: [{
data: 'price',
valueFormatter(value) {
return value ? `$${value.toFixed(2)}` : '';
}
}]
}" />

Key differences

AspectvalueFormatterrenderer
PurposeTransform the valueComplete cell rendering
ScopeValue transformation onlyDOM structure, styling, accessibility
PerformanceFaster (called before renderer)More overhead (full DOM manipulation)
Use caseSimple formatting (units, prefixes)Complex layouts, custom HTML
ReturnsFormatted valueNothing (modifies DOM directly)

Using renderer and valueFormatter together

Using both renderer and valueFormatter together is recommended when you need both value formatting and custom DOM structure. This approach separates concerns: valueFormatter handles value transformation, while renderer focuses on DOM manipulation. This separation improves maintainability and code clarity. The valueFormatter executes first, transforming the value, and then the renderer receives the formatted value:

<HotTable :settings="{
columns: [{
data: 'amount',
valueFormatter(value) {
return `$${value.toFixed(2)}`;
},
renderer(hotInstance, td, row, col, prop, value, cellProperties) {
td.innerHTML = `<div class='amount-cell'><span class='currency'>${value}</span></div>`;
}
}]
}" />

In this example, valueFormatter adds the currency symbol and formatting, while renderer wraps it in a custom DOM structure with additional styling.

Configuration options and API

APIs

Configuration options

Core methods

Hooks

Result

You now have a custom cell renderer that controls how cell content appears in the DOM. You can use a built-in renderer by alias, register and reuse your own with registerRenderer(), or write inline renderer functions for full control over the cell’s HTML structure.